Index: /palm/trunk/SOURCE/diffusion_w.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_w.f90	(revision 1319)
+++ /palm/trunk/SOURCE/diffusion_w.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -48,24 +54,4 @@
 ! kmym_y/_z and kmyp_y/_z change to kmym and kmyp
 !
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng 
-!
-! 366 2009-08-25 08:06:27Z raasch
-! bc_lr/bc_ns replaced by bc_lr_cyc/bc_ns_cyc
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Wall functions now include diabatic conditions, call of routine wall_fluxes,
-! z0 removed from argument list
-!
-! 20 2007-02-26 00:12:32Z raasch
-! Bugfix: ddzw dimensioned 1:nzt"+1"
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.12  2006/02/23 10:38:03  raasch
-! nzb_2d replaced by nzb_w_outer, wall functions added for all vertical walls,
-! +z0 in argument list
-! WARNING: loops containing the MAX function are still not properly vectorized!
-!
 ! Revision 1.1  1997/09/12 06:24:11  raasch
 ! Initial revision
@@ -77,5 +63,6 @@
 !------------------------------------------------------------------------------!
 
-    USE wall_fluxes_mod
+    USE wall_fluxes_mod,                                                       &
+        ONLY :  wall_fluxes, wall_fluxes_acc
 
     PRIVATE
@@ -99,15 +86,31 @@
     SUBROUTINE diffusion_w
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &          
+           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           
+       USE control_parameters,                                                 & 
+           ONLY :  topography
+           
+       USE grid_variables,                                                     &     
+           ONLY :  ddx, ddy, fwxm, fwxp, fwym, fwyp, wall_w_x, wall_w_y
+           
+       USE indices,                                                            &            
+           ONLY :  nxl, nxr, nyn, nys, nzb, nzb_w_inner, nzb_w_outer, nzt
+           
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmym, kmyp
-
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus, wsvs
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
+       
+       REAL(wp) ::  kmxm  !:
+       REAL(wp) ::  kmxp  !:
+       REAL(wp) ::  kmym  !:
+       REAL(wp) ::  kmyp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsvs  !:
 
 
@@ -116,7 +119,7 @@
 !--    walls, if neccessary
        IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes( wsus, 0.0, 0.0, 0.0, 1.0, nzb_w_inner, &
+          CALL wall_fluxes( wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, nzb_w_inner,             &
                             nzb_w_outer, wall_w_x )
-          CALL wall_fluxes( wsvs, 0.0, 0.0, 1.0, 0.0, nzb_w_inner, &
+          CALL wall_fluxes( wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, nzb_w_inner,             &
                             nzb_w_outer, wall_w_y )
        ENDIF
@@ -208,15 +211,32 @@
     SUBROUTINE diffusion_w_acc
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           
+       USE control_parameters,                                                 &
+           ONLY :  topography
+           
+       USE grid_variables,                                                     &
+           ONLY : ddx, ddy, fwxm, fwxp, fwym, fwyp, wall_w_x, wall_w_y
+           
+       USE indices,                                                            &
+           ONLY :  i_left, i_right, j_north, j_south, nxl, nxr, nyn, nys, nzb, &
+                   nzb_w_inner, nzb_w_outer, nzt
+                   
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmym, kmyp
-
-       REAL, DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus, wsvs
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
+       
+       REAL(wp) ::  kmxm  !:
+       REAL(wp) ::  kmxp  !:
+       REAL(wp) ::  kmym  !:
+       REAL(wp) ::  kmyp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsus  !:
+       REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  wsvs  !:
        !$acc declare create ( wsus, wsvs )
 
@@ -225,8 +245,8 @@
 !--    walls, if neccessary
        IF ( topography /= 'flat' )  THEN
-          CALL wall_fluxes_acc( wsus, 0.0, 0.0, 0.0, 1.0, nzb_w_inner, &
-                                nzb_w_outer, wall_w_x )
-          CALL wall_fluxes_acc( wsvs, 0.0, 0.0, 1.0, 0.0, nzb_w_inner, &
-                                nzb_w_outer, wall_w_y )
+          CALL wall_fluxes_acc( wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp,          &
+                                nzb_w_inner, nzb_w_outer, wall_w_x )
+          CALL wall_fluxes_acc( wsvs, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp,          &
+                                nzb_w_inner, nzb_w_outer, wall_w_y )
        ENDIF
 
@@ -324,15 +344,31 @@
     SUBROUTINE diffusion_w_ij( i, j )
 
-       USE arrays_3d
-       USE control_parameters
-       USE grid_variables
-       USE indices
+       USE arrays_3d,                                                          &          
+           ONLY :  ddzu, ddzw, km, tend, u, v, w
+           
+       USE control_parameters,                                                 & 
+           ONLY :  topography
+           
+       USE grid_variables,                                                     &     
+           ONLY :  ddx, ddy, fwxm, fwxp, fwym, fwyp, wall_w_x, wall_w_y
+           
+       USE indices,                                                            &            
+           ONLY :  nxl, nxr, nyn, nys, nzb, nzb_w_inner, nzb_w_outer, nzt
+           
+       USE kinds
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-       REAL    ::  kmxm, kmxp, kmym, kmyp
-
-       REAL, DIMENSION(nzb:nzt+1) ::  wsus, wsvs
+       INTEGER(iwp) ::  i     !:
+       INTEGER(iwp) ::  j     !:
+       INTEGER(iwp) ::  k     !:
+       
+       REAL(wp) ::  kmxm  !:
+       REAL(wp) ::  kmxp  !:
+       REAL(wp) ::  kmym  !:
+       REAL(wp) ::  kmyp  !: 
+
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsus
+       REAL(wp), DIMENSION(nzb:nzt+1) ::  wsvs
 
 
@@ -369,6 +405,6 @@
 !--       Calculate the horizontal momentum fluxes w'u' and/or w'v'
           IF ( wall_w_x(j,i) /= 0.0 )  THEN
-             CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i), &
-                               wsus, 0.0, 0.0, 0.0, 1.0 )
+             CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i),     &
+                               wsus, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp )
           ELSE
              wsus = 0.0
@@ -376,6 +412,6 @@
 
           IF ( wall_w_y(j,i) /= 0.0 )  THEN
-             CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i),  &
-                               wsvs, 0.0, 0.0, 1.0, 0.0 )
+             CALL wall_fluxes( i, j, nzb_w_inner(j,i)+1, nzb_w_outer(j,i),     &
+                               wsvs, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp )
           ELSE
              wsvs = 0.0
Index: /palm/trunk/SOURCE/diffusivities.f90
===================================================================
--- /palm/trunk/SOURCE/diffusivities.f90	(revision 1319)
+++ /palm/trunk/SOURCE/diffusivities.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -36,26 +42,4 @@
 ! adjustment of mixing length to the Prandtl mixing length at first grid point
 ! above ground removed
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 137 2007-11-28 08:50:10Z letzel
-! Bugfix for summation of sums_l_l for flow_statistics
-! Vertical scalar profiles now based on nzb_s_inner and ngp_2dh_s_inner.
-!
-! 97 2007-06-21 08:23:15Z raasch
-! Adjustment of mixing length calculation for the ocean version.
-! This is also a bugfix, because the height above the topography is now
-! used instead of the height above level k=0.
-! theta renamed var, dpt_dz renamed dvar_dz, +new argument var_reference
-! use_pt_reference renamed use_reference
-!
-! 57 2007-03-09 12:05:41Z raasch
-! Reference temperature pt_reference can be used in buoyancy term
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.24  2006/04/26 12:16:26  raasch
-! OpenMP optimization (+sums_l_l_t), sqrt_e must be private
 !
 ! Revision 1.1  1997/09/19 07:41:10  raasch
@@ -69,18 +53,37 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  dd2zu, e, kh, km, l_grid, l_wall
+        
+    USE control_parameters,                                                    &
+        ONLY:  atmos_ocean_sign, e_min, g, outflow_l, outflow_n, outflow_r,    &
+                outflow_s, use_single_reference_value, wall_adjustment
+                
+    USE indices,                                                               &
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb_s_inner, nzb, nzt
+    USE kinds
+    
     USE pegrid
-    USE statistics
+    
+    USE statistics,                                                            &
+        ONLY :  rmask, statistic_regions, sums_l_l
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, omp_get_thread_num, sr, tn
-
-    REAL    ::  dvar_dz, l, ll, l_stable, sqrt_e, var_reference
-
-    REAL    ::  var(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
+    INTEGER(iwp) ::  i                   !:
+    INTEGER(iwp) ::  j                   !:
+    INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  omp_get_thread_num  !:
+    INTEGER(iwp) ::  sr                  !:
+    INTEGER(iwp) ::  tn                  !:
+
+    REAL(wp)     ::  dvar_dz             !:
+    REAL(wp)     ::  l                   !:
+    REAL(wp)     ::  ll                  !:
+    REAL(wp)     ::  l_stable            !:
+    REAL(wp)     ::  sqrt_e              !:
+    REAL(wp)     ::  var_reference       !:
+
+    REAL(wp)     ::  var(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  !:
 
 
@@ -136,8 +139,8 @@
                 IF ( dvar_dz > 0.0 ) THEN
                    IF ( use_single_reference_value )  THEN
-                      l_stable = 0.76 * sqrt_e / &
+                      l_stable = 0.76 * sqrt_e /                               &
                                  SQRT( g / var_reference * dvar_dz ) + 1E-5
                    ELSE
-                      l_stable = 0.76 * sqrt_e / &
+                      l_stable = 0.76 * sqrt_e /                               &
                                  SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5
                    ENDIF
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 1319)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -26,24 +32,6 @@
 ! $Id$
 !
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
-!
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-! Calls of exchange_horiz are modified.
-!
-! 420 2010-01-13 15:10:53Z franke
-! Loop was split to make runs reproducible when using ifort compiler
-!
-! 75 2007-03-22 09:54:05Z raasch
-! xrp, ynp eliminated, 2nd+3rd argument removed from exchange horiz
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.11  2006/08/04 14:31:59  raasch
-! izuf renamed iran
 !
 ! Revision 1.1  1998/02/04 15:40:45  raasch
@@ -60,19 +48,35 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE random_function_mod
+    USE control_parameters,   &
+        ONLY:  dist_nxl, dist_nxr, dist_nyn, dist_nys, dist_range,             &
+               disturbance_amplitude, disturbance_created,                     &
+               disturbance_level_ind_b, disturbance_level_ind_t, iran,         &
+               random_generator, topography
+                
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+        
+    USE indices,                                                               &
+        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        
+    USE kinds
+    
+    USE random_function_mod,                                                   &
+        ONLY: random_function
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-    INTEGER ::  nzb_uv_inner(nysg:nyng,nxlg:nxrg)
-
-    REAL    ::  randomnumber,                             &
-                dist1(nzb:nzt+1,nysg:nyng,nxlg:nxrg), &
-                field(nzb:nzt+1,nysg:nyng,nxlg:nxrg)
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  dist2
+    INTEGER(iwp) ::  i  !:
+    INTEGER(iwp) ::  j  !:
+    INTEGER(iwp) ::  k  !:
+    
+    INTEGER(iwp) ::  nzb_uv_inner(nysg:nyng,nxlg:nxrg) !:
+
+    REAL(wp) ::  randomnumber  !:
+    
+    REAL(wp) ::  dist1(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  !:
+    REAL(wp) ::  field(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  !:
+    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  dist2  !:
 
 
@@ -92,8 +96,8 @@
           DO  j = dist_nys(dist_range), dist_nyn(dist_range)
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
-                randomnumber = 3.0 * disturbance_amplitude * &
+                randomnumber = 3.0 * disturbance_amplitude *                   &
                                ( random_function( iran ) - 0.5 )
-                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  &
-                     nyn >= j ) &
+                IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.         &
+                     nyn >= j )                                                &
                 THEN
                    dist1(k,j,i) = randomnumber
@@ -107,12 +111,12 @@
              DO  k = disturbance_level_ind_b, disturbance_level_ind_t
 #if defined( __nec )
-                randomnumber = 3.0 * disturbance_amplitude * &
+                randomnumber = 3.0 * disturbance_amplitude *                   &
                                ( RANDOM( 0 ) - 0.5 )
 #else
                 CALL RANDOM_NUMBER( randomnumber )
-                randomnumber = 3.0 * disturbance_amplitude * &
+                randomnumber = 3.0 * disturbance_amplitude *                   &
                                 ( randomnumber - 0.5 )
 #endif
-                IF ( nxl <= i .AND. nxr >= i .AND. nys <= j .AND. nyn >= j ) &
+                IF ( nxl <= i .AND. nxr >= i .AND. nys <= j .AND. nyn >= j )   &
                 THEN
                    dist1(k,j,i) = randomnumber
@@ -137,6 +141,6 @@
         DO  j = nys, nyn
           DO  k = disturbance_level_ind_b-1, disturbance_level_ind_t+1
-             dist2(k,j,i) = ( dist1(k,j,i-1) + dist1(k,j,i+1) &
-                            + dist1(k,j+1,i) + dist1(k+1,j,i) &
+             dist2(k,j,i) = ( dist1(k,j,i-1) + dist1(k,j,i+1)                  &
+                            + dist1(k,j+1,i) + dist1(k+1,j,i)                  &
                             ) / 12.0
           ENDDO
Index: /palm/trunk/SOURCE/disturb_heatflux.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 1319)
+++ /palm/trunk/SOURCE/disturb_heatflux.f90	(revision 1320)
@@ -16,9 +16,15 @@
 !
 ! Copyright 1997-2014 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -26,18 +32,6 @@
 ! $Id$
 !
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
-!
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 555 2010-09-07 07:32:53Z raasch
-! Bugfix in if statement
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.7  2006/08/04 14:35:07  raasch
-! Additional parameter in function random_gauss which limits the range of the
-! created random numbers, izuf renamed iran
 !
 ! Revision 1.1  1998/03/25 20:03:47  raasch
@@ -54,14 +48,25 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  shf
+        
+    USE control_parameters,                                                    &
+        ONLY:  iran, surface_heatflux, wall_heatflux
+        
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+        
+    USE kinds
+    
+    USE indices,                                                               &
+        ONLY:  nx, nxl, nxr, ny, nyn, nys, nzb_s_inner
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j
-    REAL    ::  random_gauss, randomnumber
+    INTEGER(iwp) ::  j  !:
+    INTEGER(iwp) ::  i  !:
+    
+    REAL(wp) ::  random_gauss  !:
+    REAL(wp) ::  randomnumber  !:
 
 
@@ -73,5 +78,5 @@
        DO  j = 0, ny
           randomnumber = random_gauss( iran, 5.0 )
-          IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j ) &
+          IF ( nxl <= i  .AND.  nxr >= i  .AND.  nys <= j  .AND.  nyn >= j )   &
           THEN
              IF ( nzb_s_inner(j,i) == 0 )  THEN
Index: /palm/trunk/SOURCE/eqn_state_seawater.f90
===================================================================
--- /palm/trunk/SOURCE/eqn_state_seawater.f90	(revision 1319)
+++ /palm/trunk/SOURCE/eqn_state_seawater.f90	(revision 1320)
@@ -1,5 +1,5 @@
  MODULE eqn_state_seawater_mod
 
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 ! This file is part of PALM.
 !
@@ -16,9 +16,15 @@
 !
 ! Copyright 1997-2014 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -28,8 +34,4 @@
 ! 1036 2012-10-22 13:43:42Z raasch
 ! code put under GPL (PALM 3.9)
-!
-! 388 2009-09-23 09:40:33Z raasch
-! Potential density is additionally calculated in eqn_state_seawater,
-! first constant in array den also defined as type double.
 !
 ! 97 2007-06-21 08:23:15Z raasch
@@ -45,4 +47,6 @@
 ! eqn_state_seawater_func calculates density.
 !------------------------------------------------------------------------------!
+    
+    USE kinds
 
     IMPLICIT NONE
@@ -51,20 +55,22 @@
     PUBLIC eqn_state_seawater, eqn_state_seawater_func
 
-    REAL, DIMENSION(12), PARAMETER ::  nom =                             &
-                      (/ 9.9984085444849347D2,   7.3471625860981584D0,   &
-                        -5.3211231792841769D-2,  3.6492439109814549D-4,  &
-                         2.5880571023991390D0,  -6.7168282786692354D-3,  &
-                         1.9203202055760151D-3,  1.1798263740430364D-2,  &
-                         9.8920219266399117D-8,  4.6996642771754730D-6,  &
-                        -2.5862187075154352D-8, -3.2921414007960662D-12 /)
-
-    REAL, DIMENSION(13), PARAMETER ::  den =                             &
-                      (/ 1.0D0,                  7.2815210113327091D-3,  &
-                        -4.4787265461983921D-5,  3.3851002965802430D-7,  &
-                         1.3651202389758572D-10, 1.7632126669040377D-3,  &
-                        -8.8066583251206474D-6, -1.8832689434804897D-10, &
-                         5.7463776745432097D-6,  1.4716275472242334D-9,  &
-                         6.7103246285651894D-6, -2.4461698007024582D-17, &
-                        -9.1534417604289062D-18 /)
+    REAL(wp), DIMENSION(12), PARAMETER ::  nom =                               &
+                          (/ 9.9984085444849347D2,   7.3471625860981584D0,     &
+                            -5.3211231792841769D-2,  3.6492439109814549D-4,    &
+                             2.5880571023991390D0,  -6.7168282786692354D-3,    &
+                             1.9203202055760151D-3,  1.1798263740430364D-2,    &
+                             9.8920219266399117D-8,  4.6996642771754730D-6,    &
+                            -2.5862187075154352D-8, -3.2921414007960662D-12 /)
+                          !:
+
+    REAL(wp), DIMENSION(13), PARAMETER ::  den =                               &
+                          (/ 1.0D0,                  7.2815210113327091D-3,    &
+                            -4.4787265461983921D-5,  3.3851002965802430D-7,    &
+                             1.3651202389758572D-10, 1.7632126669040377D-3,    &
+                            -8.8066583251206474D-6, -1.8832689434804897D-10,   &
+                             5.7463776745432097D-6,  1.4716275472242334D-9,    &
+                             6.7103246285651894D-6, -2.4461698007024582D-17,   &
+                            -9.1534417604289062D-18 /)
+                          !:
 
     INTERFACE eqn_state_seawater
@@ -85,12 +91,29 @@
     SUBROUTINE eqn_state_seawater
 
-       USE arrays_3d
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  hyp, prho, pt_p, rho, sa_p
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb_s_inner, nzt
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-
-       REAL ::  pden, pnom, p1, p2, p3, pt1, pt2, pt3, pt4, sa1, sa15, sa2
+       INTEGER(iwp) ::  i  !:
+       INTEGER(iwp) ::  j  !:
+       INTEGER(iwp) ::  k  !:
+
+       REAL(wp) ::  pden  !:
+       REAL(wp) ::  pnom  !:
+       REAL(wp) ::  p1    !:
+       REAL(wp) ::  p2    !:
+       REAL(wp) ::  p3    !:
+       REAL(wp) ::  pt1   !:
+       REAL(wp) ::  pt2   !:
+       REAL(wp) ::  pt3   !:
+       REAL(wp) ::  pt4   !:
+       REAL(wp) ::  sa1   !:
+       REAL(wp) ::  sa15  !:
+       REAL(wp) ::  sa2   !:
+       
+                       
 
        DO  i = nxl, nxr
@@ -114,11 +137,11 @@
                 sa2  = sa1 * sa1
 
-                pnom = nom(1)           + nom(2)*pt1     + nom(3)*pt2     + &
-                       nom(4)*pt3       + nom(5)*sa1     + nom(6)*sa1*pt1 + &
+                pnom = nom(1)           + nom(2)*pt1     + nom(3)*pt2     +    &
+                       nom(4)*pt3       + nom(5)*sa1     + nom(6)*sa1*pt1 +    &
                        nom(7)*sa2
 
-                pden = den(1)           + den(2)*pt1     + den(3)*pt2     + &
-                       den(4)*pt3       + den(5)*pt4     + den(6)*sa1     + &
-                       den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    + &
+                pden = den(1)           + den(2)*pt1     + den(3)*pt2     +    &
+                       den(4)*pt3       + den(5)*pt4     + den(6)*sa1     +    &
+                       den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    +    &
                        den(10)*sa15*pt2
 
@@ -127,8 +150,8 @@
                 prho(k,j,i) = pnom / pden
 
-                pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  + &
+                pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  +    &
                        nom(10)*p1*sa1   + nom(11)*p2     + nom(12)*p2*pt2
 
-                pden = pden +             den(11)*p1     + den(12)*p2*pt3 + &
+                pden = pden +             den(11)*p1     + den(12)*p2*pt3 +    &
                        den(13)*p3*pt1
 
@@ -156,12 +179,16 @@
     SUBROUTINE eqn_state_seawater_ij( i, j )
 
-       USE arrays_3d
-       USE indices
+       USE arrays_3d,                                                          &
+           ONLY:  hyp, prho, pt_p, rho, sa_p
+           
+       USE indices,                                                            &
+           ONLY:  nzb_s_inner, nzt
 
        IMPLICIT NONE
 
-       INTEGER ::  i, j, k
-
-       REAL ::  pden, pnom, p1, p2, p3, pt1, pt2, pt3, pt4, sa1, sa15, sa2
+       INTEGER(iwp) ::  i, j, k
+
+       REAL(wp)     ::  pden, pnom, p1, p2, p3, pt1, pt2, pt3, pt4, sa1, sa15, &
+                        sa2
 
        DO  k = nzb_s_inner(j,i)+1, nzt
@@ -183,11 +210,11 @@
           sa2  = sa1 * sa1
 
-          pnom = nom(1)           + nom(2)*pt1     + nom(3)*pt2     + &
-                 nom(4)*pt3       + nom(5)*sa1     + nom(6)*sa1*pt1 + &
+          pnom = nom(1)           + nom(2)*pt1     + nom(3)*pt2     +          &
+                 nom(4)*pt3       + nom(5)*sa1     + nom(6)*sa1*pt1 +          &
                  nom(7)*sa2
 
-          pden = den(1)           + den(2)*pt1     + den(3)*pt2     + &
-                 den(4)*pt3       + den(5)*pt4     + den(6)*sa1     + &
-                 den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    + &
+          pden = den(1)           + den(2)*pt1     + den(3)*pt2     +          &
+                 den(4)*pt3       + den(5)*pt4     + den(6)*sa1     +          &
+                 den(7)*sa1*pt1   + den(8)*sa1*pt3 + den(9)*sa15    +          &
                  den(10)*sa15*pt2
 
@@ -196,7 +223,7 @@
           prho(k,j,i) = pnom / pden
 
-          pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  + &
+          pnom = pnom +             nom(8)*p1      + nom(9)*p1*pt2  +          &
                  nom(10)*p1*sa1   + nom(11)*p2     + nom(12)*p2*pt2
-          pden = pden +             den(11)*p1     + den(12)*p2*pt3 + &
+          pden = pden +             den(11)*p1     + den(12)*p2*pt3 +          &
                  den(13)*p3*pt1
 
@@ -221,9 +248,20 @@
 ! Equation of state as a function
 !------------------------------------------------------------------------------!
-    REAL FUNCTION eqn_state_seawater_func( p, pt, sa )
+    REAL(wp) FUNCTION eqn_state_seawater_func( p, pt, sa )
 
        IMPLICIT NONE
 
-       REAL ::  p, p1, p2, p3, pt, pt1, pt2, pt3, pt4, sa, sa15, sa2
+       REAL(wp) ::  p      !:
+       REAL(wp) ::  p1     !:
+       REAL(wp) ::  p2     !:
+       REAL(wp) ::  p3     !:
+       REAL(wp) ::  pt     !:
+       REAL(wp) ::  pt1    !:
+       REAL(wp) ::  pt2    !:
+       REAL(wp) ::  pt3    !:
+       REAL(wp) ::  pt4    !:
+       REAL(wp) ::  sa     !:
+       REAL(wp) ::  sa15   !:
+       REAL(wp) ::  sa2    !:
 
 !
